#include "spawn.h"
#include <stdlib.h>

#include "..\algorithms.h"

void botInfo::gotHelp(Player *p, Command *c)
{
	// List commands

	if (!*c->final)
	{
		switch (p->access)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_SysOp:
			{	// SysOp-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
				sendPrivate(p, "Ext: !laglimitset [params]  !laggerdeal [#]  !lagdisplay [#]  !version  !lagtimelimit");
			}
			break;
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
				sendPrivate(p, "!about  !lagme  !lagcheck [name]  !laglimits");
			}
		}

		return;
	}

	// Specific command help

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
			if (c->checkParam("owner") || c->checkParam("all"))
			{
//				sendPrivate(p, "Ext: ");
			}
		}
	case OP_SysOp:
		{	// SysOp-level commands
			if (c->checkParam("sop") || c->checkParam("all"))
			{
//				sendPrivate(p, "Ext: ");
			}
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			if (c->checkParam("smod") || c->checkParam("all"))
			{
//				sendPrivate(p, "Ext: ");
			}
			else if (c->checkParam("laglimitset"))
			{
				sendPrivate(p, "!laglimitset [switches]  (set lag limits on various settings)");
				sendPrivate(p, "-p=[#]  (set Current PING limit)           ");
				sendPrivate(p, "-a=[#]  (set Average PING limit)           ");
				sendPrivate(p, "-s=[#]  (set ServerToClient Ploss limit)   ");
				sendPrivate(p, "-c=[#]  (set ClientToServer Ploss limit)   ");
				sendPrivate(p, "-w=[#]  (set Weapons Ploss limit)          ");
			}
			else if (c->checkParam("lagdisplay"))
			{
				sendPrivate(p, "!lagdisplay [#] (set how to display returns of !lagcheck and !lagme.  0:dont check  1:arena  2:pm)");
			}
			else if (c->checkParam("laggerdeal"))
			{
				sendPrivate(p, "!laggerdeal [#] (set how to deal with a lagger.  0:nothing 1:arena 2:arena/warn 3:arena/warn/spec)");
			}
			else if (c->checkParam("lagtimelimit"))
			{
				sendPrivate(p, "!lagtimelimit [#] (set the rate limit at which someone can do !lagcheck)");
			}
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if (c->checkParam("mod") || c->checkParam("all"))
			{
//				sendPrivate(p, "Ext: ");
			}
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
			if (c->checkParam("about"))
			{
				sendPrivate(p, "!about (query me about my function)");
			}
			else if (c->checkParam("lagme"))
			{
				sendPrivate(p, "!lagme (check yourself for lag.)");
			}
			else if (c->checkParam("lagcheck"))
			{
				sendPrivate(p, "!lagcheck [name] (check [name] for lag.)");
			}
			else if (c->checkParam("laglimits"))
			{
				sendPrivate(p, "!laglimits  (displays current lag limits in effect)");
			}
		}
	}
}

void botInfo::gotCommand(Player *p, Command *c)
{
	if (!p) return;
	if (!c) return;

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			if (c->check("version"))
			{
				sendPrivate(p, "[name:lagbot.dll] [maker:Explody Thingy (explody@sscentral.com)] [build:" PLUGIN_VERSION "]");
			}
/*
			else if (c->check("laglimitc"))
			{
				currping_limit = atoi(c->final);
				sendPrivate(p, "PING C limit set.");
			}
			else if (c->check("laglimitavg"))
			{
				avgping_limit = atoi(c->final);
				sendPrivate(p, "PING Avg limit set");
			}
			else if (c->check("laglimits2c"))
			{
				stcploss_limit = atoi(c->final);
				sendPrivate(p, "S2CPloss limit set.");
			}
			else if (c->check("laglimitc2s"))
			{
				ctsploss_limit = atoi(c->final);
				sendPrivate(p, "C2SPloss limit set");
			}
			else if (c->check("laglimitwep"))
			{
				stcweapon_limit = atoi(c->final);
				sendPrivate(p, "S2CWeapons limit set");
			}
*/

			else if(c->check("lagdisplay"))
			{
				if(isNumeric(c->final))
				{
					int final  = atoi(c->final);
					if (final >= 0 && final <= 2)
						showlag_status = atoi(c->final);
					else
						sendPrivate(p, "Invalid number");
				}
				else
					sendPrivate(p, "Must specify a number    0:ignore 1:arena 2:pm  recomend:1");
			}
			else if(c->check("laggerdeal"))
			{
				if(isNumeric(c->final))
				{
					int final  = atoi(c->final);
					if (final >= 0 && final <= 3)
						laggerwarn_status = atoi(c->final);
					else
						sendPrivate(p, "Invalid number");
				}
				else
					sendPrivate(p, "Must specify a number   0:nothing 1:arena 2:arena/warn 3:arena/warn/spec  recomend:1");
			}
			else if (c->check("laglimitset"))
			{
				_switch *s;
				// currping_limit
				if (s = c->getParam('p'))
				{
					currping_limit = atoi(s->param);
					sendPrivate(p, "Current Ping limit set");
				}
				// avgping_limit
				if (s = c->getParam('a'))
				{
					avgping_limit = atoi(s->param);
					sendPrivate(p, "Average Ping limit set");
				}
				// stcploss_limit
				if (s = c->getParam('s'))
				{
					stcploss_limit = atoi(s->param);
					sendPrivate(p, "S2C Ploss limit set");
				}
				// ctsploss_limit
				if (s = c->getParam('c'))
				{
					ctsploss_limit = atoi(s->param);
					sendPrivate(p, "C2S Ploss limit set");
				}
				// stcweapon_limit
				if (s = c->getParam('w'))
				{
					stcweapon_limit = atoi(s->param);
					sendPrivate(p, "Weapons Ploss limit set");
				}
			}
			else if(c->check("lagtimelimit"))
			{
				if(isNumeric(c->final))
				{
					lagtimelimit = atoi(c->final);
					sendPrivate(p,"Set time limit");
				}
			}
		}
	case OP_Moderator:
		{	// Moderator-level commands
			/*
			if (c->check("eavesdrop"))
			{
				eavesdropper = p;
				sendPrivate(p,"Listening in on who is performing !lagcheck");
			}*/
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
			if (c->check("about"))
			{
				sendPrivate(p, "Lag check plugin version " PLUGIN_VERSION " by Explody Thingy (explody@sscentral.com)");
			}
			else if (c->check("absoluteversion"))
			{
				sendPrivate(p,ABSOLUTE_VERSION);
			}
			else if (c->check("lagcheck"))
			{
				if(p->access == OP_Player && (get_tag(p, 0) >= 0))
				{
					sendPrivate(p,"Lag time limit exceeded.");
					break;
				}
				if (showlag_status)
				{
					set_tag(p, 0, lagtimelimit);
					sendPrivate(p, "Checking player's lag");
					PlayerLagCheck = c->final;
					PlayerReqLagCheck = p->name;
					_listnode <Player> *parse = playerlist->head;
					while (parse)
					{
						Player *p = parse->item;
						String shouldlag = p->name;
						if (shouldlag == PlayerLagCheck)
						{
							response  = PlayerReqLagCheck;
							response += " has requested to check your lag";
							sendPrivate(p, response);
							sendPrivate(p, "*lag");
						}
						parse = parse->next;
					}
				}
				else
					sendPrivate(p, "Staff has disabled this function for now");
			}
			else if (c->check("lagme"))
			{
				if (showlag_status)
				{
					PlayerReqLagCheck = p->name;
					PlayerLagCheck = p->name;
					sendPrivate(p, "*lag");
					sendPrivate(p, "Checking your lag.");
				}
				else
					sendPrivate(p, "Staff has disabled this function for now");
			}
			else if (c->check("laglimits"))
			{
				response  = "limits  C: ";
				response += currping_limit;
				response += "  AVG: ";
				response += avgping_limit;
				response += "  S2C: ";
				response += stcploss_limit;
				response += "  C2S: ";
				response += ctsploss_limit;
				response += "  S2CWeapons: ";
				response += stcweapon_limit;
				sendPrivate(p, response);
				int time = get_tag(p,0);
				if(time > 0)
				{
					response  = "You are currently over the set time limits.  Time until next check: ";
					response += time/60;
					response += " minutes and ";
					response += time%60;
					response += " seconds.";
					sendPrivate(p, response);
				}
			}
		}
	}
}

void botInfo::gotRemoteHelp(char *p, Command *c, Operator_Level l)
{
	// List commands

	if (!*c->final)
	{
		switch (l)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotRemote(char *p, Command *c, Operator_Level l)
{
	if (!c) return;

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}